#!/usr/bin/make
#
# Minix compiler sources makefile
# (C) 2005 Michael Kennett

h = h
m = modules/h
s = modules/src
u = util

# Build directories
l = image
o = obj

# executables used only in the build (e.g. LLgen)
x = $o/bin

default : $l/cpp.ansi

# Many headers are generated - pathlength is representative
$o/cpp.ansi/pathlength.h : lang/cem/cpp/Parameters
	cd $o/cpp.ansi && awk -f../../$u/shf/mk.hfiles.awk ../../lang/cem/cpp/Parameters

CPP_ANSI_STR = lang/cem/cpp/macro.str lang/cem/cpp/replace.str

$o/cpp.ansi/next.c : $(CPP_ANSI_STR)
	awk -flang/cem/cpp/next.awk $(CPP_ANSI_STR) > $@

$o/cpp.ansi/sym2str.c : lang/cem/cpp/tokenname.c
	awk -flang/cem/cpp/tokcase.awk lang/cem/cpp/tokenname.c > $@

$o/cpp.ansi/macro.h : lang/cem/cpp/macro.str
	sed -f lang/cem/cpp/allocd.sed < lang/cem/cpp/macro.str > $@

$o/cpp.ansi/replace.h : lang/cem/cpp/replace.str
	sed -f lang/cem/cpp/allocd.sed < lang/cem/cpp/replace.str > $@

$o/cpp.ansi/expression.g : lang/cem/cpp/expression.g
	cp lang/cem/cpp/expression.g $@

$o/cpp.ansi/tokenfile.g : lang/cem/cpp/tokenname.c
	sed -f lang/cem/cpp/tokenfile.sed < lang/cem/cpp/tokenname.c > $@

# Several files are generated by LLgen - use Lpars.c as representative
$o/cpp.ansi/Lpars.c : $o/cpp.ansi/tokenfile.g $o/cpp.ansi/expression.g $x/LLgen
	cd $o/cpp.ansi && ../../$x/LLgen -a -c -v -P../../$u/LLgen/lib tokenfile.g expression.g

$o/cpp.ansi/tokenfile.c : $o/cpp.ansi/Lpars.c
$o/cpp.ansi/expression.c : $o/cpp.ansi/Lpars.c

$o/cpp.ansi/char.c : lang/cem/cpp/char.tab $x/tabgen
	$x/tabgen -flang/cem/cpp/char.tab > $@

GEN_FILES = $o/cpp.ansi/pathlength.h $o/cpp.ansi/macro.h $o/cpp.ansi/replace.h $o/cpp.ansi/Lpars.c

CCPP_ANSI = -I$h -I$m -I$s/alloc -I$s/idf -I$s/input -I$s/string -I$s/system -I$o/cpp.ansi -Ilang/cem/cpp

$o/cpp.ansi/ch3bin.o : lang/cem/cpp/ch3bin.c
	$(CC) -c -DNDEBUG -o $@ $(CCPP_ANSI) lang/cem/cpp/ch3bin.c
$o/cpp.ansi/ch3mon.o : lang/cem/cpp/ch3mon.c
	$(CC) -c -DNDEBUG -o $@ $(CCPP_ANSI) lang/cem/cpp/ch3mon.c
$o/cpp.ansi/char.o : $o/cpp.ansi/char.c
	$(CC) -c -DNDEBUG -o $@ $(CCPP_ANSI) $o/cpp.ansi/char.c
$o/cpp.ansi/domacro.o : lang/cem/cpp/domacro.c
	$(CC) -c -DNDEBUG -o $@ $(CCPP_ANSI) lang/cem/cpp/domacro.c
$o/cpp.ansi/error.o : lang/cem/cpp/error.c
	$(CC) -c -DNDEBUG -o $@ $(CCPP_ANSI) lang/cem/cpp/error.c
$o/cpp.ansi/expr.o : lang/cem/cpp/expr.c
	$(CC) -c -DNDEBUG -o $@ $(CCPP_ANSI) lang/cem/cpp/expr.c
$o/cpp.ansi/expression.o : $o/cpp.ansi/expression.c
	$(CC) -c -DNDEBUG -o $@ $(CCPP_ANSI) $o/cpp.ansi/expression.c
$o/cpp.ansi/idf.o : lang/cem/cpp/idf.c
	$(CC) -c -DNDEBUG -o $@ $(CCPP_ANSI) lang/cem/cpp/idf.c
$o/cpp.ansi/init.o : lang/cem/cpp/init.c
	$(CC) -c -DNDEBUG -o $@ $(CCPP_ANSI) lang/cem/cpp/init.c
$o/cpp.ansi/input.o : lang/cem/cpp/input.c
	$(CC) -c -DNDEBUG -o $@ $(CCPP_ANSI) lang/cem/cpp/input.c
$o/cpp.ansi/LLlex.o : lang/cem/cpp/LLlex.c
	$(CC) -c -DNDEBUG -o $@ $(CCPP_ANSI) lang/cem/cpp/LLlex.c
$o/cpp.ansi/LLmessage.o : lang/cem/cpp/LLmessage.c
	$(CC) -c -DNDEBUG -o $@ $(CCPP_ANSI) lang/cem/cpp/LLmessage.c
$o/cpp.ansi/Lpars.o : $o/cpp.ansi/Lpars.c
	$(CC) -c -DNDEBUG -o $@ $(CCPP_ANSI) $o/cpp.ansi/Lpars.c
$o/cpp.ansi/main.o : lang/cem/cpp/main.c
	$(CC) -c -DNDEBUG -o $@ $(CCPP_ANSI) lang/cem/cpp/main.c
$o/cpp.ansi/next.o : $o/cpp.ansi/next.c
	$(CC) -c -DNDEBUG -o $@ $(CCPP_ANSI) $o/cpp.ansi/next.c
$o/cpp.ansi/options.o : lang/cem/cpp/options.c
	$(CC) -c -DNDEBUG -o $@ $(CCPP_ANSI) lang/cem/cpp/options.c
$o/cpp.ansi/preprocess.o : lang/cem/cpp/preprocess.c
	$(CC) -c -DNDEBUG -o $@ $(CCPP_ANSI) lang/cem/cpp/preprocess.c
$o/cpp.ansi/replace.o : lang/cem/cpp/replace.c
	$(CC) -c -DNDEBUG -o $@ $(CCPP_ANSI) lang/cem/cpp/replace.c
$o/cpp.ansi/skip.o : lang/cem/cpp/skip.c
	$(CC) -c -DNDEBUG -o $@ $(CCPP_ANSI) lang/cem/cpp/skip.c
$o/cpp.ansi/sym2str.o : $o/cpp.ansi/sym2str.c
	$(CC) -c -DNDEBUG -o $@ $(CCPP_ANSI) $o/cpp.ansi/sym2str.c
$o/cpp.ansi/tokenfile.o : $o/cpp.ansi/tokenfile.c
	$(CC) -c -DNDEBUG -o $@ $(CCPP_ANSI) $o/cpp.ansi/tokenfile.c
$o/cpp.ansi/tokenname.o : lang/cem/cpp/tokenname.c
	$(CC) -c -DNDEBUG -o $@ $(CCPP_ANSI) lang/cem/cpp/tokenname.c

CPP_ANSI_OBJS = $o/cpp.ansi/ch3bin.o $o/cpp.ansi/ch3mon.o $o/cpp.ansi/char.o \
		$o/cpp.ansi/domacro.o $o/cpp.ansi/error.o $o/cpp.ansi/expr.o \
		$o/cpp.ansi/expression.o $o/cpp.ansi/idf.o $o/cpp.ansi/init.o \
		$o/cpp.ansi/input.o $o/cpp.ansi/LLlex.o $o/cpp.ansi/LLmessage.o \
		$o/cpp.ansi/Lpars.o $o/cpp.ansi/main.o $o/cpp.ansi/next.o \
		$o/cpp.ansi/options.o $o/cpp.ansi/preprocess.o $o/cpp.ansi/replace.o \
		$o/cpp.ansi/skip.o $o/cpp.ansi/sym2str.o $o/cpp.ansi/tokenfile.o \
		$o/cpp.ansi/tokenname.o

$l/cpp.ansi : $(GEN_FILES) $(CPP_ANSI_OBJS) $o/libmodule.a
	$(CC) -o $@ $(CPP_ANSI_OBJS) -L$o -lmodule
